<?php
require_once "config.inc";
require_once "db.inc";
require_once "error.inc";
require_once "constants.inc";

function writeLog($msg, $sessionid, $userid)
{
        global $config;
        if (!$config['logging'])
        	return;

        $fp = fopen($config['log_file'], "a");

        fwrite($fp, $sessionid . " - " . $userid . " - " . $_SERVER['REMOTE_ADDR'] . " - " . date("r") . " - " . $msg . "\n");

        fclose($fp);
}

//<-----
//	Brutal Timeout:		Checks if there is any session older than the brutal timeout value specified
//						if config. If this happends, any session will be removed.
//----->

function brutal_timeout_check()
{
	global $config;

	$sql2 = "SELECT session_user_id, session_id, UNIX_TIMESTAMP(session_last_action) FROM sessions";
	$sqlResult2 = mysql_query($sql2);
	$rows = mysql_num_rows($sqlResult2);

	if($rows == 1)
	{
		$row = mysql_fetch_array($sqlResult2);

		$last = $row['UNIX_TIMESTAMP(session_last_action)'];
		$now = date("U");

		if(($now - $last) > $config['brutal_session_timeout'])
		{
                        writeLog("Session " . $row['session_id'] . " brutally timed out", "-", $rows['session_user_id']);
                        $sqlResult = mysql_query("DELETE FROM sessions WHERE session_id=" . $row['session_id']);
		}
	}
	else
	{
		for($i=0; $i<$rows; $i++)
		{
			$row = mysql_fetch_array($sqlResult2);
			$last = $row['UNIX_TIMESTAMP(session_last_action)'];
			$now = date("U");

			if(($now - $last) > $config['brutal_session_timeout'])
			{
                                writeLog("Session " . $row['session_id'] . " brutally timed out", "-", $row['session_user_id']);
                                $sqlResult = mysql_query("DELETE FROM sessions WHERE session_id=" . $row['session_id']);
			}
		}
	}
}


//<-----
//	Timeout:	Checks the current session if the session has timed out, i.e. has lasted longer
//				than the timeout value specified in config. If this happends it kills the session.
//----->

function timeout_check()
{
	global $PageID;
	global $config;

	$sql = "SELECT UNIX_TIMESTAMP(session_last_action), session_user_id FROM sessions WHERE session_id=" . $_REQUEST['id'];
	$sqlResult = mysql_query($sql);
	$rows = mysql_num_rows($sqlResult);

	if($rows == 1)
	{
		$row = mysql_fetch_array($sqlResult);

		$last = $row['UNIX_TIMESTAMP(session_last_action)'];
		$now = date("U");

		if(($now - $last) > $config['session_timeout'])
		{
                        writeLog("Session " . $_REQUEST['id'] . " timed out", $_REQUEST['id'], $rows['session_user_id']);
                        $sqlResult = mysql_query("DELETE FROM sessions WHERE session_id=" . $_REQUEST['id']);
			error("session timeout");
			exit;
		}
		else
		{
			if($PageID == "")
				$PageID = "PageID Missing";

			$sql = "UPDATE sessions SET session_last_page=CONCAT('" . $PageID . ":', SUBSTRING_INDEX(session_last_page, ':', 1), ':', NOW()) WHERE session_id=" . $_REQUEST['id'];
			$sqlResult = mysql_query($sql);
		}
	}
	else
	{
		while($row = mysql_fetch_array($sqlResult))
		{
			$last = $row['UNIX_TIMESTAMP(session_last_action)'];
			$now = date("U");

			if(($now - $last) > $config['session_timeout'])
			{
                                writeLog("Session " . $_REQUEST['id'] . " timed out", $_REQUEST['id'], $rows['session_user_id']);
                                $sqlResult = mysql_query("DELETE FROM sessions WHERE session_id=" . $_REQUEST['id']);
				error("session timeout");
				exit;
			}
			else
			{
				if(!isset($PageID))
					$PageID = "PageID Missing";

				$sql = "UPDATE sessions SET session_last_page=CONCAT('" . $PageID . ":', SUBSTRING_INDEX(session_last_page, ':', 1), ':', NOW()) WHERE session_id=" . $_REQUEST['id'];
				$sqlResult = mysql_query($sql);
			}
		}
	}
}

function get_idletime($session_id)
{
	global $PageID;
	global $config;
	global $langText;

	$sql = "SELECT UNIX_TIMESTAMP(session_last_action), session_user_id FROM sessions WHERE session_id=" . $session_id;
	$sqlResult = mysql_query($sql);
	$row = mysql_fetch_array($sqlResult);

	$last = $row['UNIX_TIMESTAMP(session_last_action)'];
	$now = date("U");

	$idle = $now - $last;

	if($idle > 3600)
	{
		$hours = sprintf("%01d", ($idle / 3600));
		$idle -= ($hours * 3600);
		$minutes = sprintf("%01d", ($idle/60));

		return "<b>" . $hours . "</b>" . $langText['HOURS'] . ", <b>" . $minutes . "</b>" . $langText['MINUTES'];
	}
	else
	{
		$minutes = sprintf("%01d", ($idle/60));
		return "<b>" . $minutes . "</b>" . $langText['MINUTES'];
	}
}

//<-----
//	Auth:	Creates and returns a random md5 salted string as the auth of a session. The string that
//			is md5 salted is of random length, specified by $auth_len and contains randomly
//			all characters from a-z including 0-9.
//----->
function session_get_auth()
{
	srand((double) microtime() * 1000000);
	$auth_len = rand(10, 30);

    $allchars = 'abcdefghijklnmopqrstuvwxyz0123456789';
    $string = '';

    mt_srand ((double) microtime() * 1000000);

    for ($i = 0; $i < $auth_len; $i++)
    {

	    $string .= $allchars{mt_rand (0,(strlen($allchars)-1))};
    }

	$session_auth = md5($string);

    return $session_auth;

}

//<-----
//	ID:	Creates and returns a random 16-digit numerical string based on microtime, userid of the user and the ip
//		of the clent accessing the page.
//----->
function session_get_id(&$userid)
{
	$ip = getenv("REMOTE_ADDR");
	$ip = str_replace(".", "", $ip);

	srand((double)microtime() * 1000000);
	$id_end = ((rand(1000000000, getrandmax()))*(int)$ip);

	$session_id = $userid . $id_end;
	$session_id = str_replace(".", "", $session_id);
	$session_id = substr($session_id, 0, 10);

	return $session_id;
}

//<-----
//	Verification:	Creates and returns a md5 encrypted string of a sting consisting of the environment
//					variables REMOPTE_HOST, REMOTE_ADDR and HTTP_USER_AGENT.
//----->
function session_get_verification()
{
	$remote_host = getenv("REMOTE_HOST");
	$remote_addr = getenv("REMOTE_ADDR");
	$http_user_agent = getenv("HTTP_USER_AGENT");

	$verification = $remote_host . $remote_addr . $http_user_agent;
	$verification = md5($verification);

	return $verification;
}

//<-----
// Create:	Creates a session linked to the userid sent to the function that can be accessed
//			through $userid within the function.
//----->
function session_create(&$userid)
{
	brutal_timeout_check();

	//<-----
	//	?:	Creates or accesses the different variables needed to create a session.
	//----->
	$ip = getenv("REMOTE_ADDR");

	$today = getdate();
	$start = $today['year'] . "-" . $today['mon'] . "-" . $today['mday'] . " " . $today['hours'] . ":" . $today['minutes'] . ":" . $today['seconds'];

	$session_id = session_get_id($userid);
	$session_auth = session_get_auth();

	//<-----
	//	?:	Performs the mySQL syntax that adds the session to the database.
	//----->
	$sql = "INSERT INTO sessions SET session_id=" . $session_id . ", session_auth='" . $session_auth . "', session_verification='" . session_get_verification() . "', session_ip='" . $ip . "', session_start='" . $start . "', session_user_id=" . $userid;
	$sqlResult = mysql_query($sql);

	//<-----
	//	?:	Verifies if the session has been added to the database.
	//----->
	if(!mysql_affected_rows())
	{
		error("session create fail");
		exit;
	}

        writeLog("Session created with auth " . $session_auth, $session_id, $userid);

        //<-----
	// ?:	Creates and returns a string that contains the id and auth that will be posted in the GET when
	//		login.php creates the session.
	//----->
	$get_string = "id=" . $session_id . "&auth=" . $session_auth;
	return $get_string;

}

//<-----
//	Destroy:	Destroys the session with session_id and userid retrieved from GET as para
//				meters and returns 1 if sucess, else 0.
//----->
function session_terminate($userid = USER_ID)
{
	$sql = "DELETE FROM sessions WHERE session_id=" . $_REQUEST['id'] . " && session_user_id=" . $userid;
	$sqlResult = mysql_query($sql);

	if(mysql_affected_rows())
	{
                writeLog("Session destroyed with auth " . $_REQUEST['auth'], $_REQUEST['id'], $userid);
                return 1;
	}
	else
	{
		return 0;
	}
}

//<-----
// Verify:	Verifies the session according to 3 critera:
//			1.	Checks if id and auth exist in GET. If not user is logged out.
//			2.	Checks wether the auth in the GET matches with the auth from the database
//				linked to the id in the GET. If it does not, the user is logged out and the
//				session specified by the id in the GET is terminated.
//			3.	Checks wether the session_get_verification in the database matches with the
//				session_get_verification now. If not, the user has either changed IP, Host or
//				User Agent and will such be logged out and the session specified by the id in the
//				GET is terminated.
//----->
function session_verify($verification_trigger = "")
{
	if(!isset($_REQUEST['auth']) or !isset($_REQUEST['id']))
	{
		error("session violation");
		//die("You have made some FUFFENS in the URL-Bar! GDM U!");
	}
	else
	{
		$sql = "SELECT session_auth FROM sessions WHERE session_id=" . $_REQUEST['id'];
		$sqlResult = mysql_query($sql);
		$row = mysql_fetch_array($sqlResult);

		if($_REQUEST['auth'] != $row['session_auth'])
		{
			error("session violation");
			//die("You have made some FUFFENS in the URL-Bar! GDM U!");
		}
		else
		{
			$sql = "SELECT session_verification FROM sessions WHERE session_id=" . $_REQUEST['id'];
			$sqlResult = mysql_query($sql);
			$row = mysql_fetch_array($sqlResult);

			if(session_get_verification() != $row['session_verification'] && $verification_trigger == "")
			{
				error("session violation");
				//die("You have made some FUFFENS in the URL-Bar! Verification incorrect!");
			}
			else
			{
				timeout_check();
			}
		}
	}

	strip_request();
}

//<-----
// Strip:	Strips all tags from $_REQUEST. To be run with session_verify().
//----->
function strip_request()
{
	foreach ($_REQUEST as $key => $value)
	{
		$_REQUEST[$key] = strip_tags($value);

		if (!get_magic_quotes_gpc()) {
			$_REQUEST[$key] = addslashes($_REQUEST[$key]);
		}
	}
}

?>
